# 创建Settings设置类---功能对应的设置


class Settings():
    """
        《外星人入侵》的所有设置的类
    """
    def __init__(self):
        """
            初始化游戏的静态设置
        """
        # 屏幕宽度和高度、背景颜色设置
        self.screen_width = 1200
        self.screen_height = 800
        self.bg_color = (230, 230, 230)

        # 飞船数量的设置
        self.ship_limit = 3

        # 子弹设置
        self.bullet_width = 3
        self.bullet_height = 10
        self.bullet_color = 255, 0, 0

        # 设置屏幕上可同时出现的子弹数
        self.bullet_allowed = 8

        # 外星人设置
        self.fleet_drop_speed = 10

        # 加快游戏的节奏的速度
        self.speedup_scale = 1.1

        # 提高外星人得分节奏
        self.score_scale = 1.5

        self.initialize_dynamic_settings()

    def initialize_dynamic_settings(self):
        """初始化随游戏进行而变化的动态设置"""

        # 飞船移动速度
        self.ship_speed_factor = 2.5

        # 子弹移动速度
        self.bullet_speed_factor = 2

        # 外星人移动速度
        self.alien_speed_factor = 1

        # 每个外星人初始得分点
        self.alien_points = 50

        # fleet_direction为1表示向右移动  为-1表示向左移动
        self.fleet_direction = 1

    def increase_wen(self):
        """返回最初速度"""
        self.alien_speed_factor = 1
        # print("游戏重新开始后的初始速度：" + str(self.alien_speed_factor))

    def increase_speed(self):
        """逐渐提高速度设置"""
        self.ship_speed_factor *= self.speedup_scale
        self.bullet_speed_factor *= self.speedup_scale
        self.alien_speed_factor *= self.speedup_scale
        # print("游戏过程中依次累加的速度：" + str(self.alien_speed_factor) + "\n")

        # 逐渐提高外星人单次得分
        self.alien_points = int(self.alien_points * self.score_scale)
        # print(self.alien_points)